function [imageall,imgh,imgw] = applyBbMask(points,rgb,bb,Rtilt,maskColor,modeltmp)
    if max(rgb)>1,
       rgb =double(rgb)/255;
    end
    maskRatio = 1/3;    
    % remove nan points
    isInvalid = sum(isnan(points),2) > 0;
    points(isInvalid,:) = [];
    rgb(isInvalid,:) = [];
    isInvalid =  sum(isnan(modeltmp.XYZworldframe),2)>0;
    modeltmp.XYZworldframe(isInvalid,:) = [];
    % find points inside bb
    isInBb = points(:,1) >= bb(1) & points(:,1) <= bb(1) + bb(4) & ...
             points(:,2) >= bb(2) & points(:,2) <= bb(2) + bb(5) & ...
             points(:,3) >= bb(3) & points(:,3) <= bb(3) + bb(6);
             
    % mask points inside with mask color
    rgborg =rgb;
    rgb(isInBb,:) = bsxfun(@plus, (1-maskRatio)*rgb(isInBb,:), maskRatio*maskColor);
    
    % project point to 2D space
    points2d = round(project3dPtsTo2d(points,Rtilt,[1,1]));
    points2d(:,1) = points2d(:,1) - min(points2d(:,1)) + 1;
    points2d(:,2) = points2d(:,2) - min(points2d(:,2)) + 1;
    image = 255*ones(max(points2d(:,2)),max(points2d(:,1)),3);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),1*ones(size(points2d,1),1))) = rgb(:,1);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),2*ones(size(points2d,1),1))) = rgb(:,2);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),3*ones(size(points2d,1),1))) = rgb(:,3);
    
    [imgh,imgw,k] =size(image);
    h = floor(size(image,1)/2);
    w = floor(size(image,2)/3);  
    
    % apply rotation
    center1 = bb(1:3)+0.5*bb(4:6);
    center2 = 0.5*(max(modeltmp.XYZworldframe)+min(modeltmp.XYZworldframe));
    %topright1 =bb(1:3)+bb(4:6);
    %topright2 =max(modeltmp.XYZworldframe);
    bbsearch = [center2-[1,1,1],2,2,2];
    modelshift = bsxfun(@minus,modeltmp.XYZworldframe,center2-center1);
    Rz = getRotationMatrix('x',0);
    imagepts1 =renderPointCloud([points(isInBb,:);modelshift],[rgborg(isInBb,:);repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,Rz,Rtilt,h,w);
    Rz = getRotationMatrix('y',pi/6);
    imagepts2 =renderPointCloud([points(isInBb,:);modelshift],[rgborg(isInBb,:);repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,Rz,Rtilt,h,w);
    
    imagepts  =255*ones(size(image,1),w,3);
    imagepts(1:h,:,:) = imagepts1; 
    imagepts(h+1:2*h,:,:) = imagepts2;
    
    %top view of whole
    Rz = getRotationMatrix('x',0*pi);
    topview =renderPointCloud([points; modelshift],[rgb;repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,Rz,Rtilt,size(image,1),floor(size(image,1)));
    topview_oth=renderPointCloud_orthogonal([points; modeltmp.XYZworldframe],[rgb;repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,size(image,1),floor(size(image,1)),bbsearch);
    
    detectdepth = renderPointCloud_depth(points(isInBb,:),Rtilt,size(image,1),floor(size(image,2)));
    modeldepth = renderPointCloud_depth(modeltmp.XYZworldframe,Rtilt,size(image,1),floor(size(image,2)));
    model_moved_depth =renderPointCloud_depth(modelshift,Rtilt,size(image,1),floor(size(image,2)));
    gaps = 255*ones(size(image,1),5,3);
    imageall= [image,imagepts,topview,topview_oth,detectdepth,gaps,model_moved_depth,gaps,modeldepth];
    
%    imshow(imageall); pause;
%    [~,bb2dDraw] = project3dBbsTo2d(bb, R);
%    visualizeProjected3dBb(bb2dDraw);
end  

function out = roundwithboud(points2d,image_scale,size_d)
out = min(max(round(points2d*image_scale),1),size_d);
end