function [imageall,imgh,imgw] = applyBbMaskTightBB(points,rgb,bb,tightBB,gtBB,Rtilt,maskColor,modeltmp)
    maskRatio = 1/3;
    
    % remove nan points
    isInvalid = sum(isnan(points),2) > 0;
    points(isInvalid,:) = [];
    rgb(isInvalid,:) = [];
    isInvalid =  sum(isnan(modeltmp.XYZworldframe),2)>0;
    modeltmp.XYZworldframe(isInvalid,:) = [];
    % find points inside bb
    isInBb = ptsInTightBB(points,tightBB);
             
    % mask points inside with mask color
    rgborg =rgb;
    rgb(isInBb,:) = bsxfun(@plus, (1-maskRatio)*rgb(isInBb,:), maskRatio*maskColor);
    
    % project point to 2D space
    points2d = round(project3dPtsTo2d(points,Rtilt));
    points2d(:,1) = points2d(:,1) - min(points2d(:,1)) + 1;
    points2d(:,2) = points2d(:,2) - min(points2d(:,2)) + 1;
    image = 255*ones(max(points2d(:,2)),max(points2d(:,1)),3);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),1*ones(size(points2d,1),1))) = rgb(:,1);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),2*ones(size(points2d,1),1))) = rgb(:,2);
    image(sub2ind(size(image),points2d(:,2),points2d(:,1),3*ones(size(points2d,1),1))) = rgb(:,3);
    
    [imgh,imgw,k] =size(image);
    h = floor(size(image,1)/2);
    w = floor(size(image,2)/3);  
    
    % apply rotation
    center1 = bb(1:3)+0.5*bb(4:6);
    center2 = 0.5*(max(modeltmp.XYZworldframe)+min(modeltmp.XYZworldframe));
    bbsearchEnlarge = 1;%max([size(modeltmp.svm.w,2)*0.1,size(modeltmp.svm.w,1)*0.1,1]);
    bbsearch = [center2-[1,1,1]*bbsearchEnlarge,[2,2,2]*bbsearchEnlarge];
    %topright1 =bb(1:3)+bb(4:6);
    %topright2 =max(modeltmp.XYZworldframe);
    modelshift = bsxfun(@minus,modeltmp.XYZworldframe,center2-center1);
    Rz = getRotationMatrix('x',0);
    imagepts1 =renderPointCloud([points(isInBb,:);modelshift],[rgborg(isInBb,:);repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,Rz,Rtilt,h,w);
    Rz = getRotationMatrix('y',pi/6);
    imagepts2 =renderPointCloud([points(isInBb,:);modelshift],[rgborg(isInBb,:);repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,Rz,Rtilt,h,w);
    
    imagepts  =255*ones(size(image,1),w,3);
    imagepts(1:h,:,:) = imagepts1; 
    imagepts(h+1:2*h,:,:) = imagepts2;
    
    % front view 
    Rz = getRotationMatrix('x',0*pi);
    frontview =renderPointCloud([points; modelshift],[rgb;repmat([1,0,0],[size(modeltmp.XYZworldframe,1),1])],bb,Rz,Rtilt,size(image,1),floor(size(image,1)));
    %top view of whole
   [topview_oth,minbound2d,minbound3d,imageScale,camDist]  =renderPointCloud_orthogonal([points; modeltmp.XYZworldframe],[rgb;repmat([0,0,1],[size(modeltmp.XYZworldframe,1),1])],bb,size(image,1),floor(size(image,1)),bbsearch);
    % draw gt box on topview_oth
    for i=1:length(gtBB)      
        topview_oth =drawtopviewBBstructBB(gtBB(i),minbound2d,imageScale,topview_oth,[1,1,0],image);
    end  
    % draw tight bb on topview
    topview_oth =drawtopviewBBstructBB(tightBB,minbound2d,imageScale,topview_oth,[0,1,0],image);
      
    detectdepth = renderPointCloud_depth(points(isInBb,:),Rtilt,size(image,1),floor(size(image,2)));
    model_moved_depth =renderPointCloud_depth(modelshift,Rtilt,size(image,1),floor(size(image,2)));
    modeldepth = renderPointCloud_depth(modeltmp.XYZworldframe,Rtilt,size(image,1),floor(size(image,2)));
 
    gaps = 255*ones(size(image,1),5,3);
    imageall= [image,imagepts,frontview,topview_oth,detectdepth,gaps,model_moved_depth,gaps,modeldepth];
    
%    imshow(imageall); pause;
%    [~,bb2dDraw] = project3dBbsTo2d(bb, R);
%    visualizeProjected3dBb(bb2dDraw);
end  

function out = roundwithboud(points2d,image_scale,size_d)
out = min(max(round(points2d*image_scale),1),size_d);
end

function topview_oth =drawtopviewBBstructBB(BB,minbound2d,imageScale,topview_oth,BBcolor,image)
         gtbbpoints = get_corners_of_bb3d(BB);
        gtbbpoints([1,2,3,4,5,6,7,8],:) = gtbbpoints([8 4 5 1 7 3 6 2],:);
%        gtbbpoints(:,2) = gtbbpoints(:,2) - minbound3d(2) + camDist;
       points2d = [gtbbpoints(:,1),-1*gtbbpoints(:,2)];
       points2d(:,1) = points2d(:,1) - minbound2d(1) + 1;
       points2d(:,2) = points2d(:,2) - minbound2d(2) + 1;

        points2d(:,1) = min(max(round(points2d(:,1) * imageScale(1)),1),size(image,1));
        points2d(:,2) = min(max(round(points2d(:,2) * imageScale(2)),1),size(image,1));
%        points2d2Draw =points2d';
%        points2d2Draw =reshape(points2d2Draw(:),16,[]);
        bb2dX = transpose(reshape(points2d(:,1),8,[]));
        bb2dY = transpose(reshape(points2d(:,2),8,[]));
        topview_oth = drawBb2d(topview_oth,bb2dX,bb2dY,BBcolor);
end