function [isNotOccluded,isInBb,centerDepth,fillRatio] = getBbMask(bb,points3d,R)
    corners = get_corners_of_bb3d(bb);
    
    % points inside bb
    isInBb = points3d(:,3) >= min(corners(:,3)) & points3d(:,3) <= max(corners(:,3));
    bbX = double(corners(:,1));
    bbY = double(corners(:,2));
    idx = convhull(bbX,bbY);
    isInBb = isInBb & inpolygon(points3d(:,1),points3d(:,2),bbX(idx),bbY(idx));
%     isInBb = points3d(:,1) >= min(corners(:,1)) & points3d(:,1) <= max(corners(:,1)) & ...
%                     points3d(:,2) >= min(corners(:,2)) & points3d(:,2) <= max(corners(:,2)) & ...
%                     points3d(:,3) >= min(corners(:,3)) & points3d(:,3) <= max(corners(:,3));
                
    % points behind bb
    points3dOriginal = (R' * points3d')';
    cornersOriginal = (R' * corners')';
    isNotOccluded = isInBb | points3dOriginal(:,2) > max(cornersOriginal(:,2));
    
    % compute ratio of actual bb over input bb
    if sum(isInBb) == 0,
        fillRatio = 0;
    else
        fillRatio = (max(points3d(isInBb,1)) - min(points3d(isInBb,1))) / (max(corners(:,1)) - min(corners(:,1))) * ...
                    (max(points3d(isInBb,2)) - min(points3d(isInBb,2))) / (max(corners(:,2)) - min(corners(:,2))) * ...
                    (max(points3d(isInBb,3)) - min(points3d(isInBb,3))) / (max(corners(:,3)) - min(corners(:,3)));
    end

    % center depth
    centerDepth = mean(corners(:,2));
end