function depthMap = project3dPtsToDepthMap(points3d,Rtilt,crop,mapSize)
    %% inverse of get_aligned_point_cloud
    points3d = (Rtilt'*points3d')';
    
    %% inverse rgb_plane2rgb_world
    camera_params;
    
    % Now, swap Y and Z.
    points3d(:, [2, 3]) = points3d(:,[3, 2]);
    
    % Make the original consistent with the camera location:
    x3 = points3d(:,1);
    y3 = -points3d(:,2);
    z3 = points3d(:,3);
    
    xx = x3 * fx_rgb ./ z3 + cx_rgb;
    yy = y3 * fy_rgb ./ z3 + cy_rgb;
    
    if ~exist('crop','var') || isempty(crop)
        xx = xx - 41 + 1;
        yy = yy - 45 + 1;
    else
        xx = xx - crop(2) + 1;
        yy = yy - crop(1) + 1;
    end
    
    %% compute depth map using z-buffer
    if ~exist('mapSize','var') || isempty(mapSize),
        mapSize = [427, 561];
    end
    
    x = round(xx);
    y = round(yy);
    z = z3;
%     x = x - min(x(:)) + 1;
%     y = y - min(y(:)) + 1;
%     mapSize = [max(y), max(x)];
    isValid = x >= 1 & x <= mapSize(2) & y >= 1 & y <= mapSize(1);
    x = x(isValid);
    y = y(isValid);
    z = z(isValid);
    depthMap = accumarray([y(:) x(:)],z(:),mapSize,@min);
end