function result_complete = evaluate_complete...
                            (className,allBb3d,allBb3dtight,allTestImgIds,allBb2d,groundTruthBbs,gtLabels,doNMS)
    if exist('doNMS','var')&&doNMS
        fprintf('sorting detections...\n');
        [~,idx] = sort(allBb3d(:,7),'descend');
        allBb3d = allBb3d(idx,:);
        allBb3dtight =allBb3dtight(idx,:);
        allTestImgIds = allTestImgIds(idx);
        allBb2d = allBb2d(idx,:);
        % non-max suppression
        uniqueTestImgIds = unique(allTestImgIds);
        discard = false(size(allBb3d,1),1);
        for i = 1:length(uniqueTestImgIds),
            idx = find(allTestImgIds == uniqueTestImgIds(i));
            pick = nmsMe_3d([allBb3d(idx,1:3),allBb3d(idx,1:3)+allBb3d(idx,4:6),allBb3d(idx,7)],.25);
            discardCurr = false(size(allBb3d,1),1);
            discardCurr(idx(setdiff(1:length(idx),pick))) = true;
            discard = discard | discardCurr;
        end
        allBb3d(discard,:) = [];
        allBb3dtight(discard,:) = [];
        allTestImgIds(discard) = [];
        allBb2d(discard,:)  = [];
    end
%% 3D     
    [apScore,precision,recall,isTp,isFp,isMissed,gtIdx,maxOverlaps,numOfgt,gtIdxall] = ...
        computePRCurveTightBB(className,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,zeros(length(groundTruthBbs),1));
    result3d_all = struct('apScore',apScore,'precision',precision,'recall',recall);
    
    [apScore,precision,recall] = ...
        computePRCurveTightBB(className,allBb3d,allBb3dtight,allTestImgIds,groundTruthBbs,gtLabels~=1);
    result3d_good = struct('apScore',apScore,'precision',precision,'recall',recall);
%% 2D
    allBb2d_nms = crop2DBB(allBb2d,427,561);
    allTestImgIds_nms = allTestImgIds;

    [apScore,precision,recall] = ...
            computePRCurve2D(className,allBb2d_nms,allTestImgIds_nms,groundTruthBbs,zeros(length(groundTruthBbs),1)); 
    result2d_all = struct('apScore',apScore,'precision',precision,'recall',recall);

    [apScore,precision,recall] =...
            computePRCurve2D(className,allBb2d_nms,allTestImgIds_nms,groundTruthBbs,gtLabels~=1);
    result2d_good = struct('apScore',apScore,'precision',precision,'recall',recall);
    result_complete =struct('result3d_all',result3d_all,'result3d_good',result3d_good,...
                            'result2d_good',result2d_good,'result2d_all',result2d_all);
end
