%{
%%
clear all
fname = 'shape'
load(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/learnfeature_' fname '.mat']);
norm_mean = mean(a);
a_norm =bsxfun(@minus,a,norm_mean);
norm_scale = max(std(a_norm,1,1),0.000001);
a_norm = bsxfun(@rdivide,a_norm,norm_scale);

repcenter =sum(bsxfun(@plus,a_norm,norm_mean./norm_scale)~=0,2)==0;
size(a_norm)
a_norm(repcenter,:)=[];
size(a_norm)
[IDX,shape_center] = kmeans(a_norm,49,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
shape_center =[-1*norm_mean./norm_scale;shape_center];
save(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_' fname ],'shape_center','norm_mean','norm_scale','IDX');

stdfall =[];
for i =1:1:1000,
    fearaw = a_norm(randi(size(a_norm,1),1),:);
    fea1 =pdist2(fearaw,shape_center); 
    stdfall = [stdfall std(fea1)];
end
stdf = median(stdfall);
save(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_' fname ],'shape_center','stdf','IDX','norm_mean','norm_scale');
%%
clear all
fname = 'curv'
load(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/learnfeature_' fname '.mat']);
norm_mean = mean(a);
a_norm =bsxfun(@minus,a,norm_mean);
norm_scale = max(std(a_norm,1,1),0.000001);
a_norm = bsxfun(@rdivide,a_norm,norm_scale);

% figure,
% subplot(3,1,1)
% plot(mean(a_norm));
% title('mean of different dim')
% subplot(3,1,2)
% plot(max(a_norm));
% title('max of different dim')
% subplot(3,1,3)
% plot(std(a_norm,1,1))
% title('std of different dim')

repcenter =sum(bsxfun(@plus,a_norm,norm_mean./norm_scale)~=0,2)==0;
size(a_norm)
a_norm(repcenter,:)=[];
size(a_norm)
[IDX,curv_center] = kmeans(a_norm,49,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
curv_center =[-1*norm_mean./norm_scale;curv_center];
save('/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_curv','curv_center','norm_mean','norm_scale','IDX');

stdfall =[];
for i =1:1:1000,
    fearaw = a_norm(randi(size(a_norm,1),1),:);
    fea1 =pdist2(fearaw,curv_center); 
    stdfall = [stdfall std(fea1)];
end
stdf = median(stdfall);
save('/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_curv','curv_center','stdf','IDX','norm_mean','norm_scale');




clear all
fname = 'normal'
load(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/learnfeature_' fname '.mat']);
norm_mean = mean(a);
a_norm =bsxfun(@minus,a,norm_mean);
norm_scale = max(std(a_norm,1,1),0.000001);
a_norm = bsxfun(@rdivide,a_norm,norm_scale);
%{
figure,
subplot(3,1,1)
plot(mean(a_norm));
title('mean of different dim')
subplot(3,1,2)
plot(max(a_norm));
title('max of different dim')
subplot(3,1,3)
plot(std(a_norm,1,1))
title('std of different dim')
figure,
plot(norm_scale(:))
%}
repcenter =sum(bsxfun(@plus,a_norm,norm_mean./norm_scale)~=0,2)==0;
size(a_norm)
a_norm(repcenter,:)=[];
size(a_norm)
[IDX,normal_center] = kmeans(a_norm,49,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
normal_center =[-1*norm_mean./norm_scale;normal_center];
save('/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_normal','normal_center','norm_mean','norm_scale','IDX');

stdfall =[];
for i =1:1:1000,
    fearaw = a_norm(randi(size(a_norm,1),1),:);
    fea1 =pdist2(fearaw,normal_center); 
    stdfall = [stdfall std(fea1)];
end
stdf = median(stdfall);
save('/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_normal','normal_center','stdf','IDX','norm_mean','norm_scale');


clear all
Qnum =6;
feamun =1000;
[startLoc,endLoc]=get_start_end_ind(Qnum,feamun);
fname = 'tsdf'
load(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/learnfeature_' fname '.mat']);
stickfea =a(:,1:size(startLoc,2));
stick_norm_mean = mean(stickfea);
stickfea_norm =bsxfun(@minus,stickfea,stick_norm_mean);
stick_norm_scale = max(std(stickfea_norm,1,1),0.000001);
stickfea_norm = bsxfun(@rdivide,stickfea_norm,stick_norm_scale);

size(stickfea_norm)
repcenter =sum(bsxfun(@plus,stickfea_norm,stick_norm_mean./stick_norm_scale)~=0,2)==0;
stickfea_norm(repcenter,:)=[];
size(stickfea_norm)

[IDX,stick_center] = kmeans(stickfea_norm,49,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
stick_center =[-1*stick_norm_mean./stick_norm_scale;stick_center];

countfea =a(:,size(endLoc,2)+1:end);
count_norm_mean = mean(countfea);
count_norm =bsxfun(@minus,countfea,count_norm_mean);
count_norm_scale = max(std(count_norm,1,1),0.000001);
count_norm = bsxfun(@rdivide,count_norm,count_norm_scale);

center1 = (1-count_norm_mean)./count_norm_scale;
repcenter1 =sum(bsxfun(@minus,count_norm,center1)~=0,2)==0;
center2 = (-1-count_norm_mean)./count_norm_scale;
repcenter2 =sum(bsxfun(@minus,count_norm,center2)~=0,2)==0;
size(count_norm)
count_norm(repcenter1|repcenter2,:) =[];
size(count_norm)
[IDX2,count_center] = kmeans(count_norm,48,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
count_center = [center1;center2;count_center];

stdf_stickall =[];
stdf_countall =[];
for i =1:1:1000,
    fearaw = a(randi(size(a,1),1),:);
    fea1 =pdist2(fearaw(1:1000),stick_center); 
    stdf_stickall(i) = std(fea1);
    fea2 =pdist2(fearaw(1001:end),count_center); 
    stdf_countall(i) = std(fea2);
end
stdf_count = median(stdf_countall);
stdf_stick = median(stdf_stickall);

save(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_' fname ],...
       'count_center','count_norm_scale','count_norm_mean',...
       'stick_center','stick_norm_mean','stick_norm_scale',...
       'IDX','IDX2','stdf_count','stdf_stick','Qnum','feamun');
%}
   
   
clear all
Qnum =6;
feamun =1000;
[startLoc,endLoc]=get_start_end_ind(Qnum,feamun);
fname = 'point'
load(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/learnfeature_' fname '.mat']);
stickfea =a(:,1:size(startLoc,2));
stick_norm_mean = mean(stickfea);
stickfea_norm =bsxfun(@minus,stickfea,stick_norm_mean);
stick_norm_scale = max(std(stickfea_norm,1,1),0.000001);
stickfea_norm = bsxfun(@rdivide,stickfea_norm,stick_norm_scale);

size(stickfea_norm)
repcenter =sum(bsxfun(@plus,stickfea_norm,stick_norm_mean./stick_norm_scale)~=0,2)==0;
stickfea_norm(repcenter,:)=[];
size(stickfea_norm)

[IDX,stick_center] = kmeans(stickfea_norm,49,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
stick_center =[-1*stick_norm_mean./stick_norm_scale;stick_center];

countfea =a(:,size(endLoc,2)+1:end);
count_norm_mean = mean(countfea);
count_norm =bsxfun(@minus,countfea,count_norm_mean);
count_norm_scale = max(std(count_norm,1,1),0.000001);
count_norm = bsxfun(@rdivide,count_norm,count_norm_scale);

center1 = (0-count_norm_mean)./count_norm_scale;
repcenter1 =sum(bsxfun(@minus,count_norm,center1)~=0,2)==0;
size(count_norm)
count_norm(repcenter1,:) =[];
size(count_norm)
[IDX2,count_center] = kmeans(count_norm,49,'EmptyAction', 'singleton','MaxIter',500);% N-by-P data matrix X
count_center = [center1;count_center];

stdf_stickall =[];
stdf_countall =[];
for i =1:1:1000,
    fearaw = a(randi(size(a,1),1),:);
    fea1 =pdist2(fearaw(1:1000),stick_center); 
    stdf_stickall(i) = std(fea1);
    fea2 =pdist2(fearaw(1001:end),count_center); 
    stdf_countall(i) = std(fea2);
end
stdf_count = median(stdf_countall);
stdf_stick = median(stdf_stickall);

save(['/n/fs/modelnet/Code/detector_change_feature/featurecenters/featurecenter_' fname ],...
       'count_center','count_norm_scale','count_norm_mean',...
       'stick_center','stick_norm_mean','stick_norm_scale',...
       'IDX','IDX2','stdf_count','stdf_stick','Qnum','feamun');




