% find tight bounding box 
function bb3dTight = getTightBB(vmat)
        zmin = min(vmat(3,:));
        zmax = max(vmat(3,:));
        [C,V]= PCA(vmat(1:2,:),2);
        Vproj = C'*vmat(1:2,:);
        [projmin,Minind] = min(Vproj,[],2);
        [projmax,Maxind] = max(Vproj,[],2);
        bb3dTight = [];
        bb3dTight.basis = [C' [0;0]; 0 0 1]; % one row is one basis
        centroid2D = C*[0.5*(projmax(1)+projmin(1)); 0.5*(projmax(2)+projmin(2))];
        bb3dTight.coeffs = [projmax(1)-projmin(1), projmax(2)-projmin(2), zmax-zmin]/2;
        bb3dTight.centroid = [centroid2D(1), centroid2D(2), 0.5*(zmax+zmin)];
end