function [depth,K,crop,minv,maxv,vmat,fmat,vmatOrg,segMask] = off2im(offfile, ratio, xzRot, tilt, objz, objx,objy,modelsize,addfloor,enlargefloor,enlargewall)

if ~exist('xzRot', 'var')
    xzRot =0;
end
if ~exist('tilt', 'var')
    tilt = - 0.1*pi;
end
if ~exist('objz', 'var')
    objz = 2 + rand() * 5;   % 2 to 5
end
if ~exist('objx', 'var')
    objx = (rand()*0.5-0.25) .* objz;
end
if ~exist('ratio', 'var')
    ratio = 1;
end
if ~exist('objy', 'var')
    objy = -1.3;
end
if ~exist('modelsize', 'var')
    modelsize = [1;1;1]*rand()*1.5+0.5;
end
if ~exist('addfloor','var')
    addfloor =0;
end
if ~exist('enlargefloor','var')
    enlargefloor =1;
end
if ~exist('enlargewall','var')
    enlargewall =0;
end


%% Camera Paramter
imw = 640 * ratio; 
imh = 480 * ratio;
fx_rgb = 519.1638* 1;
fy_rgb = 519.1638* 1;
cx_rgb = imw/2;
cy_rgb = imh/2;
K=[fx_rgb 0 cx_rgb; 0 fy_rgb cy_rgb; 0 0 1];

C = [0;0;0];   

z_near = 0.3;
z_far_ratio = 1.2;
Ryzswi = [1, 0, 0; 0, 0, 1; 0, 1, 0];

%%
offobj = offLoader(offfile);
offobj.vmat = Ryzswi * offobj.vmat;
Robj = genRotMat(xzRot);
Rcam = genTiltMat(tilt);
P = K * Rcam * [eye(3), -C];

vmat = scalePoints(offobj.vmat, [objx;objy;objz], modelsize);
vmatOrg = scalePoints(Robj * vmat, [objx;objy;objz], modelsize);
fmatOrg = offobj.fmat;
minv = min(vmat, [], 2);
maxv = max(vmat, [], 2);
fmat = offobj.fmat;

floorVertexStart =[];
if addfloor&&enlargefloor>=0,
   %make the floor larger
   v1=[minv(1)-enlargefloor;minv(2);minv(3)-enlargefloor];
   v2=[minv(1)-enlargefloor;minv(2);maxv(3)+enlargefloor];
   v3=[maxv(1)+enlargefloor;minv(2);maxv(3)+enlargefloor];
   v4=[maxv(1)+enlargefloor;minv(2);minv(3)-enlargefloor];
   
   floorVertexStart = length(vmat)+1;
   vmat = [vmat,[v1,v2,v3,v4]];
   fmat = [offobj.fmat,[[length(vmat)-4;length(vmat)-1;length(vmat)-2;length(vmat)-4],[length(vmat)-3-1;length(vmat)-1-1;length(vmat)-2-1;length(vmat)-3-1]]];
   offobj.fmat=fmat;
end

wallVertexStart =[];
if enlargewall>=0,
    iiiddd = find(offfile =='/');
    offname = offfile(iiiddd(end)+1:end);
    if strcmp(offname,'toilet_000000062.off')||strcmp(offname,'night_stand_000000028.off')||strcmp(offname,'night_stand_000000007.off')||strcmp(offname,'night_stand_000000363.off')||strcmp(offname,'night_stand_000000128.off')...
            ||strcmp(offname,'night_stand_000000417.off')
       %make the wall larger
       v1=[minv(1)-enlargewall;minv(2)-enlargewall;maxv(3)];
       v2=[minv(1)-enlargewall;maxv(2)+enlargewall;maxv(3)];
       v3=[maxv(1)+enlargewall;maxv(2)+enlargewall;maxv(3)];
       v4=[maxv(1)+enlargewall;minv(2)-enlargewall;maxv(3)];
       
       wallVertexStart = length(vmat)+1;
       vmat = [vmat,v1,v2,v3,v4];
       fmat = [offobj.fmat,[length(vmat)-4;length(vmat)-1;length(vmat)-2;length(vmat)-4]...
                   ,[length(vmat)-3-1;length(vmat)-1-1;length(vmat)-2-1;length(vmat)-3-1]
                  ];
       offobj.fmat=fmat;
    elseif strcmp(offname,'toilet_000000059.off')||strcmp(offname,'night_stand_000000168.off')
        v1=[minv(1);minv(2)-enlargewall;maxv(3)+enlargewall];
        v2=[minv(1);maxv(2)+enlargewall;maxv(3)+enlargewall];
        v3=[minv(1);maxv(2)+enlargewall;minv(3)-enlargewall];
        v4=[minv(1);minv(2)-enlargewall;minv(3)-enlargewall];
       
       wallVertexStart = length(vmat)+1;
       vmat = [vmat,v1,v2,v3,v4];
       fmat = [offobj.fmat,[length(vmat)-4;length(vmat)-1;length(vmat)-2;length(vmat)-4]...
                   ,[length(vmat)-3-1;length(vmat)-1-1;length(vmat)-2-1;length(vmat)-3-1]
                  ];
       offobj.fmat=fmat;
    end
end

vmat = scalePoints(Robj * vmat, [objx;objy;objz], []);
minv = min(vmatOrg, [], 2);
maxv = max(vmatOrg, [], 2);

result = RenderMex(P, imw, imh, [vmat(1,:);vmat(2,:);vmat(3,:)], uint32(offobj.fmat))';
depth = z_near./(1-double(result)/2^32);
maxDepth = 8;
cropmask = (depth < z_near) | (depth > z_far_ratio * maxDepth);
depth(cropmask) = NaN;
crop =[1,1];
% 
if ~isempty(wallVertexStart)
    wall_result =  RenderMex(P, imw, imh, [vmat(1,wallVertexStart:wallVertexStart+3);vmat(2,wallVertexStart:wallVertexStart+3);vmat(3,wallVertexStart:wallVertexStart+3)], uint32([0 0; 3 2; 2 1; 0 0]))';
    wall_result_depth = z_near./(1-double(wall_result)/2^32);
    wall_result_depth((depth < z_near) | (depth > z_far_ratio * maxDepth)) = 0;
    wallSeg = abs(depth -wall_result_depth)<0.05;
else
    wallSeg =zeros(size(depth));
end
% 
if ~isempty(floorVertexStart)
    floor_result = RenderMex(P, imw, imh, [vmat(1,floorVertexStart:floorVertexStart+3);vmat(2,floorVertexStart:floorVertexStart+3);vmat(3,floorVertexStart:floorVertexStart+3)], uint32([0 0; 3 2; 2 1; 0 0]))';
    floor_result_depth = z_near./(1-double(floor_result)/2^32);
    floor_result_depth((depth < z_near) | (depth > z_far_ratio * maxDepth)) = 0;
    floorSeg = abs(depth -floor_result_depth)<0.05;
else
    floorSeg =zeros(size(depth));
end
objectSeg = ~isnan(depth)&~floorSeg&~wallSeg;
segMask = zeros(size(depth));
segMask(objectSeg) =1;
segMask(floorSeg>0) =2;
segMask(wallSeg>0) =3;
%imagesc(depth)
%figure,scatter3(vmat(1,:),vmat(2,:),vmat(3,:),20*ones(1,size(vmat,2)),23*ones(1,size(vmat,2)));
%xlabel('x'),ylabel('y');zlabel('z');
%pause;
%}
end

function crop = findCropRegion(mask)

[xlist, ylist] = ind2sub(size(mask), find(mask));
xmin = min(xlist); xmax = max(xlist);
ymin = min(ylist); ymax = max(ylist);
crop = [xmin, ymin, xmax - xmin, ymax - ymin];

end

function R = genRotMat(theta)

R = [cos(theta), 0, -sin(theta)
    0, 1, 0
    sin(theta), 0, cos(theta)];

end

function R = genTiltMat(theta)

R = [1, 0, 0
    0, cos(theta), -sin(theta)
    0,  sin(theta), cos(theta)];

end

function coornew = scalePoints(coor, center, size)

% function coornew = scalePoints(coor, box)
% 
% parameters:
%   coor: 3*n coordinates of n points
%   center: 3*1 the center of new point cloud
%   size: 3*1 the size of new point cloud

minv = min(coor, [], 2);
maxv = max(coor, [], 2);
oldCenter = (minv+maxv)/2;
oldSize = maxv - minv;
%size defined by height
if isempty(size)
    scale = 1;
else
    scale =size(2)./ oldSize(2);
end
%scale = min(size./ oldSize);
coornew = bsxfun(@plus, scale * coor, center-scale*oldCenter);
end
