function mesh2ply(PLYfilename, vertexes, rgb_v, edges, rgb_e, faces, rgb_f)
% coordinate is 3 * n single matrix for npoints
% rgb        is 3 * n uint8  matrix for n points range [0, 255]
   

if ~exist('rgb_v', 'var')
  rgb_v = [];
end

if ~exist('edges', 'var')
  edges = [];
end

if ~exist('rgb_e', 'var')
  rgb_e = [];
end

if ~exist('faces', 'var')
  faces = [];
end

if ~exist('rgb_f', 'var')
  rgb_f = [];
end


if size(vertexes,2)==3 && size(vertexes,1)~=3
  vertexes = vertexes';
end

edges = edges - 1;

% isValid = (~isnan(vertexes(1,:))) & (~isnan(vertexes(2,:))) & (~isnan(vertexes(3,:)));
% vertexes = vertexes(:,isValid);
% rgb_v = rgb_v(:,isValid);


%     data = reshape(typecast(reshape(single(vertexes),1,[]),'uint8'),3*4,[]);
% 
%     if nargin>2
%         if size(rgb_v,2)==3 && size(rgb_v,1)~=3
%             rgb_v = rgb_v';
%         end
%         
%         if ~isa(rgb_v,'uint8')
%             if max(rgb_v(:))<=1
%                 rgb_v = rgb_v * 255;
%             end
%         end
%         
%         if isa(rgb_v,'double')
%             rgb_v = uint8(rgb_v);
%         end
%         
%         rgb_v = rgb_v(:,isValid);
%         data = [data; rgb_v];
%     end

if ~isa(rgb_v,'uint8')
  if max(rgb_v(:))<=1
    rgb_v = rgb_v * 255;
  end
end
if isa(rgb_v,'double')
  rgb_v = round(rgb_v);
else
  rgb_v = double(rgb_v);
end

pattern_v = '%f %f %f';
if ~isempty(rgb_v)
  data_v = [vertexes; rgb_v];
  pattern_v = [pattern_v ' %d %d %d'];
else
  data_v = vertexes;
end
pattern_v = [pattern_v '\n'];


if ~isa(rgb_e,'uint8')
  if max(rgb_e(:))<=1
    rgb_e = rgb_e * 255;
  end
end
if isa(rgb_e,'double')
  rgb_e = round(rgb_e);
else
  rgb_e = double(rgb_e);
end

pattern_e = '%d %d';
if ~isempty(rgb_e)
  data_e = [edges; rgb_e];
  pattern_e = [pattern_e ' %d %d %d'];
else
  data_e = edges;
end
pattern_e = [pattern_e '\n'];

file = fopen(PLYfilename,'w');
fprintf (file, 'ply\n');
% fprintf (file, 'format binary_little_endian 1.0\n');
fprintf (file, 'format ascii 1.0\n');
fprintf (file, 'element vertex %d\n', size(vertexes,2));
fprintf (file, 'property float x\n');
fprintf (file, 'property float y\n');
fprintf (file, 'property float z\n');
if size(data_v, 1) > 3
  fprintf (file, 'property uchar red\n');
  fprintf (file, 'property uchar green\n');
  fprintf (file, 'property uchar blue\n');
end
if ~isempty(data_e)
  fprintf(file, 'element edge %d\n', size(data_e, 2));
  fprintf(file, 'property int vertex1\n');
  fprintf(file, 'property int vertex2\n');
  if size(data_e, 1) > 2
    fprintf(file, 'property uchar red\n');
    fprintf(file, 'property uchar green\n');
    fprintf(file, 'property uchar blue\n');
  end
end
fprintf(file, 'end_header\n');
% fwrite(file, data,'uint8');
fprintf(file, pattern_v, data_v);
fprintf(file, pattern_e, data_e);
fclose(file);

end
